;Splines engine
;by Ky3R [kuzmacrt(at)mail(dot)ru] +380956897707
;use as you please!) but pls write in ur game something like "Splines engine by Ky3R" =^)
;13.09.2009

Type spline
Field name$
Field points
Field currentpoint
End Type

Type sp_point
Field sp_name$
Field mdl
Field id
End Type

Function NewSpline(nm$,pts)
spl.spline=New spline
spl\name$=nm$
spl\points=pts
spl\currentpoint=1
End Function

Function CheckSpline(nm$,pts)
For spl.spline=Each spline
	If spl\name=nm$ Then spl\points=pts
Next
End Function

Function SetCurrentPoint(nm$,pt,msh)
For spl.spline=Each spline
	If spl\name=nm$ Then spl\currentpoint=pt
	
	If msh<>0 Then
		For point.sp_point=Each sp_point
			If point\id=pt Then
				HideEntity msh
				PositionEntity msh,EntityX(point\mdl),EntityY(point\mdl),EntityZ(point\mdl)
				ShowEntity msh
			End If
		Next
	End If
Next
End Function

Function DeleteSpline(nm$)
For spl.spline=Each spline
	If spl\name=nm$ Then Delete spl.spline
Next
For point.sp_point=Each sp_point
	If point\sp_name=nm$ Then
		FreeEntity point\mdl
		Delete point.sp_point
	End If
Next
End Function

Function NewPoint(x,y,z,id,nm$)
point.sp_point=New sp_point
point\mdl=CreateMesh()
PositionEntity point\mdl,x,y,z
point\id=id
point\sp_name=nm

For spl.spline=Each spline
	If spl\name$=nm Then spl\points=spl\points+1
Next
End Function

Function AnimBySpline(spl_nm$,msh,speed#,tang)
For spl.spline=Each spline
	If spl\name=spl_nm Then	
			For point.sp_point=Each sp_point		
				If point\sp_name=spl_nm$ Then
			
				If spl\currentpoint=point\id Then
					
					a_p=EntityPitch(msh)
					a_y=EntityYaw(msh)
					a_r=EntityRoll(msh)
					
					PointEntity msh,point\mdl
					MoveEntity msh,0,0,speed
					
					If tang=0 Then RotateEntity msh,a_p,a_y,a_r
					
					If EntityDistance(msh,point\mdl)<1 Then spl\currentpoint=spl\currentpoint+1
					If spl\currentpoint=spl\points Then spl\currentpoint=1
										
										
				End If
			
			End If
		Next
	End If
Next
End Function

Function SaveSpline(sp_n$,fl_n$)
file=WriteFile(fl_n$+".spline")
For spl.spline=Each spline
	If spl\name=sp_n Then
		For point.sp_point=Each sp_point
			WriteInt(file,EntityX(point\mdl))
			WriteInt(file,EntityY(point\mdl))
			WriteInt(file,EntityZ(point\mdl))
		Next
	End If
Next
CloseFile file
End Function

Function LoadSpline(sp_n$,fl_n$)
file=ReadFile(fl_n$+".spline")

While Not Eof(file)
	id=id+1
	x=ReadInt(file)
	y=ReadInt(file)
	z=ReadInt(file)
	NewPoint(x,y,z,id,sp_n$)
	pts=pts+1
Wend

NewSpline(sp_n$,pts)

CloseFile file
End Function

Function CurrentSplinePoint(nm$)
For spl.spline=Each spline
	If spl\name=nm$ Then Return spl\currentpoint
Next
End Function

Function CountSplinePoints(nm$)
a=0
For spl.spline=Each spline
	If spl\name=nm$ Then 
		For point.sp_point=Each sp_point
			If point\sp_name=nm Then 
				a=a+a
			End If
		Next
	End If
Next
Return a
End Function

Function CountSplines()
a=0
For spl.spline=Each spline
a=a+1
Next
Return a
End Function

Function DrawSpline(sp_n$,l_r,l_g,l_b,s_r,s_g,s_b)
For spl.spline=Each spline
	If spl\name=sp_n Then
		
		For point.sp_point=Each sp_point
			If point\sp_name=sp_n Then 
				CameraProject camera,EntityX(point\mdl),EntityY(point\mdl),EntityZ(point\mdl)
				x_prv=ProjectedX()
				y_prv=ProjectedY()
				Exit
			End If
		Next
		
		
		For point.sp_point=Each sp_point
			If point\sp_name=sp_n Then
								
				CameraProject camera,EntityX(point\mdl),EntityY(point\mdl),EntityZ(point\mdl)	
										
				p_x=ProjectedX()
				p_y=ProjectedY()
				
				If l_r+l_g+l_b<>0 Then
				Color l_r,l_g,l_b
				Rect p_x-4,p_y-4,8,8
				End If	
							
				If s_r+s_g+s_b<>0 Then
				Color s_r,s_g,s_b
				Line x_prv,y_prv,p_x,p_y
				End If
												
				x_prv=ProjectedX()
				y_prv=ProjectedY()	
					
			End If
		Next
	End If
Next
End Function