;-------------------------------------------
;- Rail road sample [by Ky3R]
;-------------------------------------------
;Perfect example of my engine in action =^)
;check it out!) imho it rules!)
;-------------------------------------------
;controls:
;up/down - move forward\backward
;mouse move - look around
;MMB - first person train preview
;- - - - -
;find red spherical button on the level and then press:
;LMB to stop/start train movement
;RMB to show/hide splines
;-------------------------------------------
Include "lib.bb"

Graphics3D 800,600
SetBuffer BackBuffer()

;camera
Global camera=CreateCamera()
PositionEntity camera,0,0,-25
CameraClsColor camera,0,128,255
CameraFogMode camera,1
CameraFogColor camera,0,128,255
CameraFogRange camera,500,1000
AmbientLight 200,200,200
Global light=CreateLight(1);,camera)
PositionEntity light,-100,50,0
Global listener=CreateListener(camera,0.1,1,5)
Global tr_snd=Load3DSound("train.wav")
Global snd

;font
Global fnt=LoadFont("arial",18,0,0,0)
SetFont fnt

;button
Global button=CreateSphere(12)
EntityColor button,255,0,0
PositionEntity button,0,-5,35
ScaleEntity button,5,5,5
EntityPickMode button,2

;train
Global spr=CreateCube()
ScaleEntity spr,5,5,10

;ground
Global plane=CreatePlane(12)
PositionEntity plane,0,-6,0
Global gtex=CreateTexture(128,128)
SetBuffer TextureBuffer(gtex)
For y=0 To 128
For x=0 To 128
Color 0,128+Rnd(128),0
Plot x,y
Next
Next
ScaleTexture gtex,50,50
EntityTexture plane,gtex
SetBuffer BackBuffer()

;switcher
Global switched=1
Global drw=0

;road
Global road=LoadMesh("railroad.3ds")
EntityColor road,32,32,32
PositionEntity road,0,-5,0

;and a one little but powerfull function...
;...spline loading =)

loadspline("test","railroad")

While KeyHit(1)=0
Cls

TurnEntity camera,MouseYSpeed()/4,-MouseXSpeed()/4,0
MoveMouse GraphicsWidth()/2,GraphicsHeight()/2
RotateEntity camera,EntityPitch(camera),EntityYaw(camera),0

If KeyDown(200) Then MoveEntity camera,0,0,1
If KeyDown(208) Then MoveEntity camera,0,0,-1

If switched=1 Then 
animbyspline("test",spr,0.3,1)
If ChannelPlaying(snd)=0 Then snd=EmitSound(tr_snd,spr)
End If

RenderWorld

If drw=1 Then DrawSpline("test",0,0,255,128,0,255)

ent=CameraPick(camera,MouseX(),MouseY())
If ent<>0 Then
	If ent=button Then
	Color 255,255,255
	Text GraphicsWidth()/2-StringWidth("Press this button with [LMB] to switch on/off the train! =)")/2,GraphicsHeight()/2+StringHeight("A")*5,"Press this button with [LMB] to switch on/off the train! =)"
	Text GraphicsWidth()/2-StringWidth("Press this button with [RMB] to switch on/off the spline drawing!")/2,GraphicsHeight()/2+StringHeight("A")*7,"Press this button with [RMB] to switch on/off the spline drawing!"

		If MouseHit(1) Then 
		If switched=0 Then switched=1 Else switched=0:StopChannel snd
		End If
		
		If MouseHit(2) Then 
		If drw=0 Then drw=1 Else drw=0
		End If
	End If
End If

Color 255,255,255
Text GraphicsWidth()/2-StringWidth("Press & hold [MMB] to look in first person mode!")/2,GraphicsHeight()/2-StringHeight("A")*10,"Press & hold [MMB] to look in first person mode!"


If MouseDown(3) Then
PositionEntity camera,EntityX(spr),EntityY(spr)+MeshWidth(spr),EntityZ(spr)
RotateEntity camera,EntityPitch(spr),EntityYaw(spr),EntityRoll(spr)
End If

Color 0,0,255
Line GraphicsWidth()/2-4,GraphicsHeight()/2,GraphicsWidth()/2+4,GraphicsHeight()/2
Line GraphicsWidth()/2,GraphicsHeight()/2-4,GraphicsWidth()/2,GraphicsHeight()/2+4

;FlushMouse
Flip
Wend
End